#include "inno_lidar.h"

//#include "time_utils.h"
#include "ap_utils.h"

InnoLidar::InnoLidar(ara::log::Logger &mainLog) : _wrapper("lidar_inno/lidar_inno/LidarInnoPPort", mainLog)
{
}

void InnoLidar::freeFramePackets(std::vector<InnoDataPacket *> frameData)
{
    for(InnoDataPacket *pkt : frameData)
    {
        free(pkt);
    }
}

void InnoLidar::setPointVector(InnoDataPacket* frameData)
{
	_wrapper.s.NewData(frameData);
}

void InnoLidar::newPacket()
{
	_memIndex = _wrapper.AllocateInternal();
//	printf("mem index  = %d\n", _memIndex);
	_wrapper.s.Reset();
}


void InnoLidar::setPointsVector(std::vector<InnoDataPacket *> frameData)
{
//    if(_framesQueue.size() < 1)
//    {
//        _framesQueue.push(frameData);
//        _packet_processed_count++;
//    }
//    else
//    {
//        freeFramePackets(frameData);
//        _packet_lost_count++;
//    }
}

bool InnoLidar::OnInit()
{
    _wrapper.Init(true);
    _wrapper.AllocateInternal();

	newPacket();


    return true;
}

void InnoLidar::OnSend()
{
	if(_wrapper.s.isPacketComplete())
    {
		float duration;
		{
			_wrapper.PublishRaw(_memIndex);
        }
//        std::cout << "Duration: " << duration << " milliseconds" << std::endl;
        newPacket();
    }
}

void InnoLidar::Process()
{
	_wrapper.s.Process(_wrapper.GetDataPtr(_memIndex));
}

void InnoLidar::RunThread()
{
	float t;

    while(1)
    {

//    	auto start = std::chrono::high_resolution_clock::now();
//    	{
////    	Timer("s",&t );
//
    	if(_wrapper.s.needProcess())
    	{
        Process();
        OnSend();
//
    	}
    	else
    		std::this_thread::sleep_for(std::chrono::milliseconds(1));
//        auto end = std::chrono::high_resolution_clock::now();
//        auto duration = std::chrono::duration_cast<std::chrono::microseconds>(end - start);
//        printf("duration onsend = %d\n", duration.count());
//        auto threshold = std::chrono::microseconds(3);
//        if(duration < threshold){
//            auto remaining = threshold - duration;
//            std::this_thread::sleep_for(std::chrono::milliseconds(2));
//        }
    }
}
